// UART, 2x PullDown, LED PB0

#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "board.h"

void board_init(){
    UBRR0L=(uint8_t)(F_CPU/(BAUD*16L))-1; 		// Baudrate festlegen
	UBRR0H=(uint8_t)((F_CPU/(BAUD*16L))-1)>>8; 	// Baudrate festlegen
	UCSR0B=(1<<RXEN0)|(1<<TXEN0);				// enable RX, TX 	
	DDRB=(1<<DDB0); 							// PB0-LED 1=Output
	PORTB=0b00000000;							// PB1 und PB2 low,
	TCCR2B=(1<<CS20)|(1<<CS22);					// Prescaler 128 Timertakt=3.9ms
	TIMSK2=(1<<TOIE2);							// Timer2 Overflow-Interrupt enable
	MCUCR=(1<<IVSEL);							// Interupt Tabellen Start
	ASSR=(1<<AS2);								// 32kHz Enable
	DDRD=(1<<DDD4)|(1<<DDD5)|(1<<DDD6);			// LED-PD4, HM-TRP PD5-Config, PD6-Enable, PD7-Test
	PORTD=(1<<PORTD4)|(1<<PORTD5);				// HM-TRP Com-Mode und aktiv 
} 

ISR (TIMER2_OVF_vect){		// Timer auf 1s, IRQ immer aktiv
//static char cmd[SSIZE+1];
static char c=0,s1[8];				// ;
long i,wms=0;						// Wartezeit in ms

	LED_AN;
	c=0;
	sytis=0;
	if (heicd==1) {	HM_AN;hk(NORM);uputs("HK_NORM\r\n");_delay_ms(2);} // Fallback automatisch senden Master&Slave
	if (heicd>0) heicd--;						// Heizung Fall back counter
	if (heicdf==AN){heicd=heicds;heicdf=AUS;}	// ggf. setzen
	if (st<SYMAX) st++; else st=1;				// aktuelle Synchronzeit		
	if (wtcd>0) wtcd--;							// restliche Wachzeit		

	if (devid==MASTER){
		wtcd=1;									// immer wach
		if (ss<59)ss++;else{ss=0;if(mm<59)mm++;else{mm=0;if(hh<23)hh++;else hh=0;}} // Uhr
		if (st==SYMAX){ 						// im Synchronpunkt
		   	
			if ((mm==30)&(ss<SYMAX)){				// zur vollen Stunde 
			 	uputc(SYNCHAR);		//_delay_ms(200);uputs("\r");	// Synchronzeichen
				}
			if ((mm==0)&(ss<SYMAX)){				// zur vollen Stunde 
			 	uputc(SYNCHAR);_delay_ms(200);	// Synchronzeichen
			 	uputs(" Zeit ");	if (hh<10) uputs("0");uputs(itoa(hh,s1,10));// und Zeit senden
			 	uputs(":");	if (mm<10) uputs("0");uputs(itoa(mm,s1,10));uputs("\r\n");
				}
			else {									// und Befehlweitergabe
				if (strlen(bcmd)!=0){uputc(SYNCHAR);_delay_ms(8*SYTISG);uputs(bcmd);uputs("\r\n");strcpy(bcmd,"");}	
				}		// else   Ende
			}			// SYMAX  Ende
		}				// Master Ende
	else{ 											// Aufwachen 
		if (resycd>0) resycd--;						// s seit letztem resync
		if (resycd==45) {HM_AN; uputs("HK_S\r\n");_delay_ms(2);return;}// sync-Anforderung senden ohne retrack
		if ((wtcd==0)&&(st==SYMAX)){ 				// wenn Zeit reif
			HM_AN;									// Funk nur an wenn ntig
			while ( UCSR0A & (1<<RXC0) ) c=UDR0;	// flush receive buffer
			if (resycd==0) {uputs("HK_S\r\n");wms=10*SYMAXLONG;corf=AUS;} // ggf resync und retrack
			else{ if (corf==AN) wms=10*8*SYTISK; else wms=10*8*SYTISG;} // Wartezeit in ms bis Sync 
// Totzeit des Funkmoduls zur Gangkorrektur nutzen dauert 2 Takte = 8.1ms = 81 loops
			_delay_us(100);i=TCNT2;while (TCNT2==i);	// warten bis sich was ndert
			_delay_us(3706+corus);GTCCR=(1<<PSRASY);TCNT2=(uint8_t)i+2;_delay_us(100); // corus s korrigieren					
			for (i=0;i<(wms-181);i++){				// ms warten, 10ms Totzeit und 8ms verzgerter Start
				if (UCSR0A&(1<<RXC0)){c=UDR0;break;}// sync-Zeichen empfangen (ideal) bei i=4
				if (wms==10*SYMAXLONG) TCNT2=1;		// Timer Pause whrend Resync
				_delay_us(95);						// damit Sync-Index i in 0.1 ms
				}	
			i+=81;									// + o.g. Korrektur
			if (c==SYNCHAR){						// mit sync erhalten
				GTCCR=(1<<PSRASY);					// sofort Prescaler reset, 	
				if (corf==AUS) sytis=SYTISG; else sytis=SYTISK;// Timer Startwert 3 damit HM_TRP wach //Timer auf 1 = 4ms										
				TCNT2=(uint8_t)sytis;						// Timer auf neuen Startwert
//				uputs(" i=");uputs(ltoa(i,s1,10));_delay_ms(2); // uputs("\r\n"); // testweise
				wtcd=TI_WACH;						// Wachzeit Timeout
				corxo(RESYMAX-resycd,i-(4*10*osytis));	// Gang messen unter Verwendung des alten Startwertes
				osytis=sytis;
				}
			if ((wms==SYMAXLONG)||(c==SYNCHAR)) resycd=RESYMAX;// bei jedem sync-Ereignis oder resync 
			}
		}											// ... Vor- und Nachlaufzeit beachten 
}

void corxo(int ti,int di){							// Zeit[s] seit letztem Sync, dZeit[ms]
//char s1[16];				 
	if (corf==ANS) corf=AN;							// Funkintervall erst beim 2.Durchlauf einengen
	if (corf==AUS) {dxo_n=10000;corus=100;}							// bei resync neues tracking
	if ((ti>CORTIMIN)&&(ti!=RESYMAX)){
		dxo_n+=(100000L*di)/ti;
		corus=(dxo_n*SYMAX)/1000;					// ca. +-100s pro 10s 
		if (corf==AUS) corf=ANS; 					// 2-Stufen Umschaltung
// 		uputs(" ti:");uputs(itoa(ti,s1,10));uputs("di:");uputs(itoa(di,s1,10));
//		uputs("dxo_n:");uputs(ltoa(dxo_n,s1,10));uputs("cus:");uputs(ltoa(corus,s1,10));
		}
}

void hk(int nst){				// Sollwerte relativ manipulieren
static int ost=NORM;
int pu;
	pu=(nst-ost)*CLICKS;		// bipolar
	ost=nst;
	while (pu!=0){if (pu>0) {INC_PU;pu--;} else {DEC_PU;pu++;}
		_delay_ms(50);
		}
}

int ugets(char *s,int maxi){
    uint8_t i=0;
	while (i<maxi) {
		s[i]=ugetc();
		if (s[i]=='\r')		// CR als Befehls-Ende-Zeichen
			s[i]='\0';
		if (s[i]=='\0')     // TimeOut==StringEndeZeichen
	   		break;
		i++;
		}
	return i;
}

char ugetc(void){						// liest Zeichen oder nach Timeout die '\0'
    uint16_t i=0;
    while ( !(UCSR0A & (1<<RXC0)) ) {	// UART Polling 50s
	    _delay_us(UGETC_DELAY);		
        if ( ++i > ((UGETC_TOUT*1000UL)/UGETC_DELAY) )	
            return 0x00;				// keine Zeichen - TimeOut
 		}
    return UDR0;
}

void uputs(char* s){
	for (int i=0; s[i]!=0;i++)
		uputc(s[i]);
}

void uputc(char c){
	while (!(UCSR0A & (1<<UDRE0)));	    // warte bis UDR leer 	
	UDR0=c;							    // senden
}
