#define SSIZE 32				// String-Lnge
#define SYNCHAR 	'$'			// Sync-Zeichen
#define SYMAX 		10			// Synchronperiode in Sekunden
#define SYMAXLONG	11000L		// ms bis resync
#define SYTISK		4L			// Kleiner Timer Startwert nach Sync
#define SYTISG		12L			// Groer Timer Startwert nach Sync
#define RESYMAX 	3700		// max Resynchronisationszeit
#define CORTIMIN	1700		// min. Messzeit fr Gangunterschied
#define TI_WACH		3			// Nachlaufzeit bei Sync-Zeichen
#define LED_PIN PORTD4
#define DEC_PIN PORTB1
#define INC_PIN PORTB2
#define E_PIN   PORTD6
#define HM_AN   PORTD&=~(1<<E_PIN)
#define HM_AUS  PORTD|=(1<<E_PIN)
#define LED_AN  PORTD&=~(1<<LED_PIN)
#define LED_AUS PORTD|=(1<<LED_PIN)	
#define LED_T   PORTD^=(1<<LED_PIN)	
#define LED_PU {PORTD|=(1<<LED_PIN);_delay_ms(100);PORTB&=~(1<<LED_PIN);}
#define INC_PU {DDRB|=(1<<INC_PIN);_delay_ms(50);DDRB&=~(1<<INC_PIN);} 
#define DEC_PU {DDRB|=(1<<DEC_PIN);_delay_ms(50);DDRB&=~(1<<DEC_PIN);}

#define UGETC_TOUT 10			// 1000	// ms Timeout von ugetc() 
#define UGETC_DELAY 50        	// s Abtast-Intervall von empfang() (Klingel und so ....)
#define BAUD 	9600
#define AUS	0
#define ANS	1
#define AN	2
#define MASTER  0
#define SLAVE1  1
#define SLAVE2  2
#define SLAVE3  3
#define SLAVE4  4
#define SLAVE5  5
#define EEPReadB(addr)     		eeprom_read_byte((uint8_t *)addr)     
#define EEPWriteB(addr,val)		eeprom_write_byte((uint8_t *)addr, val) 
#define ID_ADD 0x20				// ID-Adresse im EEPROM

#define AUF		1		// 
#define NORM	0
#define ZU		-1
#define INC		1
#define DEC		-1
#define LED		2
#define CLICKS  10
#define CDMO	3600
#define CDMA	600

void board_init(void);
void hk(int);
void uputc(char);
char ugetc(void);
void uputs(char*);    				// Anzahl der gelesenen Zeichen 
int ugets(char*,int maxi);			// TimeOut terminiert, max maxi Zeichen
void corxo(int,int);						// Gangkorrektur
void parse(void);

uint8_t devid,heicdf; 		// ID-Kennung, HeizungsCountDownFlag, sync-Flag
int hh,mm,ss;				// Uhr
int wtcd,st,heicd,heicds;	// Wachzeit,Synchronzeit,Heiz-Countdown: wert, sollwert
int resycd;					// Zeit seit dem letzten Resync-Ereignis
int corf;
long dxo_n,corus;			// E-9 Gangabweichung, Korrekturintervall, s-Korrektur pro Intervall
char icmd[SSIZE+1],bcmd[SSIZE+1];	// Kommando String
int osytis,sytis;			// timer start


//long dbv1,dbv2,dbv3,dbv4;			// Variablen fr D
