// Heizkrper-Programm: 
//
// Master:
//		- Quarzuhr: Stundensignal zur Synchronisation der Slaves
// 		- Broadcast-Befehl weiterreichen alle 10s 
//
// SlaveX:	
//		- periodisches Aufwachen, Synchronisation mit Master-Thermostat
//		- verzgertes Einschlafen nach Broadcast, zwecks individueller Befehle
// 
// Gemeinsam:
//		- Manipulation der Heizkrper-Thermostate
// Fuses: BODLEVEL disabled,SPIEN,EESAVE,Boot size=2048,BOOTRST,Int 8MHz 0ms, 
// todo:  gemeinsames parse mit wachzeit reaktivieren
// flash-Feher bei 4614/469
// wichtig: HM-TRP sammelt Daten vorm Senden Tout???
// Version:
// s Gangkorrektur alle 10s versuchen
// ohne resyf


#include <stdlib.h>
#include <string.h>
#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/eeprom.h>

#include "board.h"

void varinit(void); 			

int main(){
	_delay_ms(100);				    			// sauberer Start
	board_init();
 	varinit();									// ID lesen
	uputs("HK_");uputc(devid+48);uputs(" hier! \r\n");_delay_ms(2); // Meldung machen
	sei();										// Sekundentimer-IRQ aktivieren
    set_sleep_mode(SLEEP_MODE_PWR_SAVE);
	while (1){									// ziemlich schnelle Schleife
	  	if (devid==MASTER) {
			ugets(icmd,SSIZE); 					// Master liest Befehle im Hauptprogramm 
			parse();							// Kommunikation auswerten			
			}
		else {
			while ((wtcd>0)&&(ugets(icmd,SSIZE)==0));// bis Kommando, oder Schlafenszeit 
			if (strlen(icmd)>0){parse();wtcd=0;_delay_ms(2);}// Kommunikation auswerten			
			HM_AUS;LED_AUS;	sleep_mode();// Sklaven schlafen weiter bis Timer-ISR  
			}
		}									
}         
//while((UCSR0A&(1<<TXC0))==0);
void varinit(void){ 			
	if (EEPReadB(ID_ADD)==0xFF){EEPWriteB(ID_ADD, 0);uputs("HK_EEPROM_Init\r\n");}		// Status
	devid=EEPReadB(ID_ADD);			// nderung nur durch Neustart
	hh=0;mm=0;ss=0;					// Uhr 
	wtcd=0;							// erstmal syncen
	resycd=0;						//1;// danach Slave synchonisieren, Master bleibt bei 1 
	corf=AUS;						// Korrekturmodus
	st=SYMAX-1;
	osytis=4*SYTISG;				// vorheriger Timer-Startwert
	corus=0;
}

void parse(void){
void (*bootloader)( void ) = 0x7800;
char s1[8];		
char * sp;
uint8_t b;
int thh,tmm,tss;
	if(strstr(icmd,"HK_H")!=NULL){
		uputs("HK_: W(erte),S(ync),R(eset),ID<sel><neu>,T(ime) TI_hh_mm_ss MO_AN/AUS IR_AN\r\n");
		}
	if(strstr(icmd,"HK_W")!=NULL){
		if (devid==MASTER)	strcpy(bcmd,"HK_W");
        else {				
			uputs("dxo_n:");uputs(ltoa(dxo_n,s1,10));uputs("\r\n");
			uputs("cus:");uputs(ltoa(corus,s1,10));uputs("\r\n");
			}
		}
	if(strstr(icmd,"HK_S")!=NULL){
		strcpy(bcmd," ");}					
	if(strstr(icmd,"MO_AN")!=NULL){
		heicds=CDMO;heicdf=AN;strcpy(bcmd,"MO_AN");
		hk(AUF);uputs("HK_AUF\r\n");
		}
	if(strstr(icmd,"IR_MASCHINEN_AN")!=NULL){
		heicds=CDMA;heicdf=AN;strcpy(bcmd,"IR_AN");
		hk(ZU);uputs("HK_ZU\r\n");
		}
	if(strstr(icmd,"IR_AN")!=NULL){
		heicds=CDMA;heicdf=AN;strcpy(bcmd,"IR_AN");
		hk(ZU);uputs("HK_ZU\r\n");
		}
	if(strstr(icmd,"MO_AUS")!=NULL){
		strcpy(bcmd,"MO_AUS");
		hk(NORM);uputs("HK_NORM\r\n");
		}
	if(strstr(icmd,"HK_T")!=NULL){
		if (devid==MASTER){				// wenn auskommentiert -> Compiler-Fehler
			uputs("Zeit: ");
			if (hh<10) uputs("0");uputs(itoa(hh,s1,10));uputs(":");
			if (mm<10) uputs("0");uputs(itoa(mm,s1,10));uputs(":");
			if (ss<10) uputs("0");uputs(itoa(ss,s1,10));uputs("\r\n");
			}
		}
	if(strstr(icmd,"HK_ID")!=NULL){
		sp=	strstr(icmd,"HK_ID");
		if ((*(sp+5)<48)||(*(sp+5)>58)){ 		// kein Argument zw. 0...9
// lnger als IRQ-Intervall			_delay_ms(devid*1000);				// 
			uputs("ID:");uputc(devid+48);uputs("\r\n");// melden
			strcpy(bcmd,"HK_ID");				// weiter an Slaves reichen
			}
		else if ((*(sp+5)-48)==devid){			// ich bin gemeint ...
			if ((*(sp+6)>=48)&&(*(sp+6)<58)){	// neue ID ist zwischen 0..9
				b=*(sp+6)-48;
				EEPWriteB(ID_ADD,b);			// Status permanent sichern
				uputs("new ID:");uputc(b+48);uputs("\r\n");
				}
			else 
				uputs("bad ID\r\n");
			}	
		}
	if(strstr(icmd,"HK_R")!=NULL){
		uputs("Restart - Springe zum Bootloader...\r\n");
		TIMSK2&=~(1<<TOIE2);				// sonst kein Restart mglich, warum auch immer
		_delay_ms(10);
		bootloader();
		}
	if(strstr(icmd,"TI_")!=NULL){		// Zeit setzen z.B. TI_12_30
		sp=strstr(icmd,"TI_");			
		thh=(*(sp+3)-48)*10; thh+=*(sp+4)-48;
		tmm=(*(sp+6)-48)*10; tmm+=*(sp+7)-48;			 
		tss=(*(sp+9)-48)*10; tss+=*(sp+10)-48;			 
		if ( ((thh>=0)&(thh<=23))&((tmm>=0)&(tmm<=59))&((tss>=0)&(tss<=59)) )  
			{hh=thh;mm=tmm;ss=tss;uputs("HK_OK\r\n");}	     
		}								// TI_ Ende
	strcpy(icmd,"");					// erledigt 
}										// Parse Ende
